package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLHermiteResult_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLHermiteResult extends JNIObject  {
	
	
	/* @generated */
	protected ISLHermiteResult(long ptr) {
		/*** PROTECTED REGION ID(ISLHermiteResult_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	
	/* @generated */
	static ISLHermiteResult build(long ptr) {
		{
			return new ISLHermiteResult(ptr);
		}
	}
	
	
	
	
	/*** PROTECTED REGION ID(ISLHermiteResult_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	/*************************************** 
	 *	     Struct Field Accessors        * 
	 ***************************************/
	/*************************************************************
	 *	H : ISLMatrix
	 *************************************************************/
	public ISLMatrix getH() {
		return ISLMatrix.build(ISLNative.isl_hermite_result_get_H(getNativePtr(this)));
	}
	/*************************************************************
	 *	H : ISLMatrix
	 *************************************************************/
	public void setH(ISLMatrix object) {
		ISLNative.isl_hermite_result_set_H(getNativePtr(this), getNativePtr(object));
	}
	/*************************************************************
	 * Test if TH is NULL
	 *************************************************************/
	public boolean testH() {
		return ISLNative.isl_hermite_result_test_H(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	U : ISLMatrix
	 *************************************************************/
	public ISLMatrix getU() {
		return ISLMatrix.build(ISLNative.isl_hermite_result_get_U(getNativePtr(this)));
	}
	/*************************************************************
	 *	U : ISLMatrix
	 *************************************************************/
	public void setU(ISLMatrix object) {
		ISLNative.isl_hermite_result_set_U(getNativePtr(this), getNativePtr(object));
	}
	/*************************************************************
	 * Test if TU is NULL
	 *************************************************************/
	public boolean testU() {
		return ISLNative.isl_hermite_result_test_U(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	Q : ISLMatrix
	 *************************************************************/
	public ISLMatrix getQ() {
		return ISLMatrix.build(ISLNative.isl_hermite_result_get_Q(getNativePtr(this)));
	}
	/*************************************************************
	 *	Q : ISLMatrix
	 *************************************************************/
	public void setQ(ISLMatrix object) {
		ISLNative.isl_hermite_result_set_Q(getNativePtr(this), getNativePtr(object));
	}
	/*************************************************************
	 * Test if TQ is NULL
	 *************************************************************/
	public boolean testQ() {
		return ISLNative.isl_hermite_result_test_Q(getNativePtr(this)) != 0;
	}
	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_hermite_result_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_hermite_result_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_hermite_result_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLHermiteResult_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
